library static_and_instance_methods_snippet;

import 'package:unittest/unittest.dart';

// START:all
// START:static_from_instance
class Planet {
  /* START:asdf
  // ...
  static List get known { ... }
  END:asdf */
  String name;
  Planet(this.name);
  bool get isRealPlanet =>
    known.any((p) => p == this.name);
// END:static_from_instance
// END:all

  static List rocky_planets = const [
    'Mercury', 'Venus', 'Earth', 'Mars'
  ];

  static List gas_giants = const [
    'Jupiter', 'Saturn', 'Uranus', 'Neptune'
  ];

  static List get known {
    var all = [];
    all.addAll(rocky_planets);
    all.addAll(gas_giants);
    return all;
  }
// START:all
// START:close_class
}
// END:close_class
// END:all

class ComicsCollection {}

run() {
  group("[static_and_instance_methods]", (){
    var _neptune_is_real, _pluto_is_real;

    setUp((){
      // START:assign_planets
      var neptune = new Planet('Neptune');
      var pluto = new Planet('Pluto');
      // END:assign_planets

      _neptune_is_real =
        // START:neptune_is_real
        neptune.isRealPlanet
        // => true
        // END:neptune_is_real
        ;

      _pluto_is_real =
        // START:pluto_is_real
        pluto.isRealPlanet
        // => false
        // END:pluto_is_real
        ;
    });

    test('calling methods', (){
      expect(_neptune_is_real, isTrue);
      expect(_pluto_is_real, isFalse);
    });
  });
}
