library singleton_snippet;

import 'package:unittest/unittest.dart';

// START:class
class Highlander {
  static Highlander the_one;
  String name;
  
  factory Highlander(name) {
    if (the_one == null) {
      the_one = new Highlander._internal(name);
    }
	
    return the_one;
  }
  
  // private, named constructor
  Highlander._internal(this.name);
}
// END:class

run() {
  group("[singleton]", (){
    test('there is only one', (){
      // START:code
      var highlander = new Highlander('Connor Macleod');
      var another = new Highlander('Kurgan');
      highlander.name;
      // => 'Connor Macleod'
      // Nice try Kurgan...
      another.name;
      // => 'Connor Macleod'
      // END:code

      expect(
        highlander.name,
        equals(another.name)
      );
    });
  });
}
