library classes_tests;

import 'basics.dart' as Basics;
import 'private.dart' as Private;
import 'methods.dart' as Methods;
import 'method_with_type.dart' as MethodType;
import 'getter_method.dart' as Getter;
import 'setter_method.dart' as Setters;
import 'operators.dart' as Operators;
import 'call_method.dart' as CallOperator;
import 'no_such_method.dart' as NoSuchMethod;
import 'cascades.dart' as Cascades;
import 'static_methods.dart' as StaticMethods;
import 'mix_static_and_instance_methods.dart' as StaticAndInstanceMethods;
import 'subclasses.dart' as Subclasses;
import 'implements.dart' as Implements;
import 'implements_multiple.dart' as ImplementsMultiple;
import 'generative_constructor.dart' as GenerativeConstructor;
import 'lazy_instance_variable.dart' as LazyIvar;
import 'named_constructor.dart' as NamedConstructor;
import 'ry_constructors.dart' as NonDryConstructor;
import 'dry_constructors.dart' as DryConstructor;
import 'constructor_simple_parameter.dart' as ConstructorSimpleParams;
import 'constructor_this_parameter.dart' as ConstructorThisParams;
import 'constructor_optional_this.dart' as ConstructorOptionalThis;
import 'singleton.dart' as Singleton;
import 'factory.dart' as Factory;

main () {
  Basics.run();
  Private.run();
  Methods.run();
  MethodType.run();
  Getter.run();
  Setters.run();
  Operators.run();
  CallOperator.run();
  NoSuchMethod.run();
  Cascades.run();
  StaticMethods.run();
  StaticAndInstanceMethods.run();
  Subclasses.run();
  Implements.run();
  ImplementsMultiple.run();
  GenerativeConstructor.run();
  LazyIvar.run();
  NamedConstructor.run();
  NonDryConstructor.run();
  DryConstructor.run();
  ConstructorSimpleParams.run();
  ConstructorThisParams.run();
  ConstructorOptionalThis.run();
  Singleton.run();
  Factory.run();
}
