library collection_event_target_snippet;

import 'dart:html';
import 'dart:async';
import 'dart:collection';
import 'package:unittest/unittest.dart';

// START:comics_view_intro
class ComicsView {
  // called by the constructor
  _subscribeEvents() {
    if (collection == null) return;
    collection.onLoad.listen((event)=> render());
    collection.onAdd.listen((event)=> render());
  }
// END:comics_view_intro

  var collection;

  render() {
    // render the list to the page
  }
// START:comics_view_intro
}
// END:comics_view_intro

class ComicModel {}

// START:comics_collection_add
// START:comics_collection_close
// START:comics_collection_intro
class ComicsCollection extends IterableBase {
  // ...
// END:comics_collection_intro
// END:comics_collection_close
// END:comics_collection_add
  StreamController _onLoad = new StreamController.broadcast(),
                   _onAdd = new StreamController.broadcast();
  List models = [];
  // ...

  // Be List-like
  Iterator get iterator => models.iterator;

  // Be Backbone like
  Stream get onLoad => _onLoad.stream;
  Stream get onAdd => _onAdd.stream;

// START:comics_collection_add
  add(model) {
    models.add(model);
    _onAdd.add(model);
  }
// START:comics_collection_close
}
// END:comics_collection_close
// END:comics_collection_add

run() {
  group("[collection_event_target]", (){
    test('adding listeners', (){
      var hipster_collection = new ComicsCollection();

      // START:add_listeners
      hipster_collection.onAdd
        ..listen((model) { /* listener #1 */ })
        ..listen((model) { /* listener #2 */ })
        ..listen((model) { /* listener #3 */ });
      // END:add_listeners

      _test(model) {
        expect(model, isNotNull);
      }

      hipster_collection.onAdd
        ..listen((model) { /* listener #1 */ })
        ..listen(_test);
    });

  });
}
