library collection_events_snippet;

import 'dart:html';
import 'dart:async';
import 'dart:collection';
import 'package:unittest/unittest.dart';

// START:comics_collection_intro
class ComicsCollection extends IterableBase {
  StreamController _onLoad = new StreamController.broadcast(),
                   _onAdd = new StreamController.broadcast();
				   
  List models = [];
// END:comics_collection_intro
  // ...

  // Be List-like
  Iterator get iterator => models.iterator;

  // Be Backbone like
  // START: published_streams
  Stream<ComicModel> get onLoad => _onLoad.stream;
  Stream<ComicModel> get onAdd => _onAdd.stream;
  // END: published_streams

  add(model) {
    models.add(model);
    _onAdd.add(model);
  }
// START:comics_collection_close
  // ...
}
// END:comics_collection_close

class ComicsView {
  var collection;

  render() {
    // render the list to the page
  }
  // called by the constructor
  _subscribeEvents() {
    if (collection == null) return;
    collection.onLoad.listen((event)=> render());
    collection.onAdd.listen((event)=> render());
  }
}

class ComicModel {}

run() {
  group("[collection_events]", (){
    test('adding listeners', (){
      var hipster_collection = new ComicsCollection();

      // START:add_listeners
      hipster_collection.onAdd
        ..listen((model) { /* listener #1 */ })
        ..listen((model) { /* listener #2 */ })
        ..listen((model) { /* listener #3 */ });
      // END:add_listeners

      _test(model) {
        expect(model, isNotNull);
      }

      hipster_collection.onAdd
        ..listen((model) { /* listener #1 */ })
        ..listen(_test);
    });

  });
}
