library main_test;

import 'package:unittest/unittest.dart';
import 'dart:html';

import '../public/scripts/comics.dart' as Main;

final String URL_ROOT = 'http://localhost:31337/widgets';

run() {
  group("[main]", (){
    var el = new Element.html('<ul id="comics-list">');

    setUp((){
      document.body
        ..append(el)
        ..append(new Element.html('<div id="add-comic">'));

      var doc = '{"id":"42", "title": "Sandman", "author":"Neil Gaiman"}';
      return HttpRequest.
        request(URL_ROOT, method: 'post', sendData: doc);
    });

    tearDown((){
      document.body.innerHtml = '';
    });

    test('the app returns OK', (){
      expect(Main.main, returnsNormally);
    });

    test('populates the list', (){
      Main.main();
      expect(el.innerHtml, contains('Sandman'));
    });
  });
}
