library view_snippet;

import 'package:unittest/unittest.dart';

// START:baseclass
class HipsterView {
  var el, model, collection;
  HipsterView({this.el, this.model, this.collection});
}
// END:baseclass

// START:simple_redirect
class ComicBookView extends HipsterView {
  ComicBookView({el, model, collection}):
    super(el:el, model:model, collection:collection);
}
// END:simple_redirect

// START:redirect_with_body_intro
class ComicsListing extends HipsterView {
  ComicsListing({el, model, collection}):
    super(el:el, model:model, collection:collection) {
    _attachUiHandlers();
    _subscribeEvents();
  }
// END:redirect_with_body_intro

  int privatesCalled = 0;
  _attachUiHandlers() {
    privatesCalled++;
  }

  _subscribeEvents() {
    privatesCalled++;

  }
// START:redirect_with_body_close
}
// END:redirect_with_body_close

run() {
  group("[view]", (){
    test('can create a new view', (){
      var view = new ComicBookView(el:"Element");
      expect(
        view.el,
        equals('Element')
      );
    });

    test('redirecting constructor can call privates', (){
      var view = new ComicsListing(el:"Element");
      expect(
        view.privatesCalled,
        equals(2)
      );
    });
  });
}
