library booleans_snippet;

import 'package:unittest/unittest.dart';

String _str1, _str2, _str3;

run() {
  group("[booleans]", (){
    setUp((){
      /* ------------------------- */
	  // START:all
      // START:null
      var name, greeting;
      greeting = name ? "Howdy $name" : "Howdy";
      // "Howdy"
      // END:null
	  // END:all
      _str1 = greeting;

	  // START:all
      // START:string
	  
      /*** Name is still not true ***/
      name = "Bob";
      greeting = name ? "Howdy $name" : "Howdy";
      // "Howdy"
      // END:string
	  // END:all
      _str2 = greeting;

	  // START:all
       // START:boolean
	   
      greeting = (name != null) ? "Howdy $name" : "Howdy";
      // "Howdy Bob"
      // END:boolean
	  //END:all
      _str3 = greeting;
      /* ------------------------- */
    });

    test('null is false', (){
      expect(_str1, equals("Howdy"));
    });

    test('string is false', (){
      expect(_str2, equals("Howdy"));
    });

    test('only booleans can be true', (){
      expect(_str3, equals("Howdy Bob"));
    });

  });
}
