library list_iterators_snippet;

import 'package:unittest/unittest.dart';

bool _any, _every;
List _where;
num _fold;

List _for_each = [];
print(val) {
  _for_each.add(val);
}

run() {
  group("[list iterators]", (){
    setUp((){
      /* ------------------------- */
      // START:forEach
      var muppets = ['The Count', 'Bert', 'Ernie', 'Snuffleupagus'];

      muppets.forEach((muppet) {
        print("$muppet is a muppet.");
      });
      // =>
      // The Count is a muppet.
      // Bert is a muppet.
      // Ernie is a muppet.
      // Snuffleupagus is a muppet.
      // END:forEach

      _any =
      // START:any
      muppets.any((muppet) {
        return muppet.startsWith('S');
      });
      // true
      // END:any

      _every =
      // START:every
      muppets.every((muppet) {
        return muppet.startsWith('S');
      });
      // false
      // END:every

      _where =
      // START:where
      muppets.where((muppet) {
        return muppet.startsWith('S');
      });
      // ['Snuffleupagus']
      // END:where

      _fold =
      // START:fold
      muppets.fold(0, (memo, muppet) {
        return memo + muppet.length;
      });
      // 31
      // END:fold

      /* ------------------------- */

    });

    test('can forEach', (){
      expect(
        _for_each,
        equals([
          'The Count is a muppet.',
          'Bert is a muppet.',
          'Ernie is a muppet.',
          'Snuffleupagus is a muppet.'
        ])
      );
    });

    test('can report if some elements match', (){
      expect(_any, isTrue);
    });

    test('can report if every elements match', (){
      expect(_every, isFalse);
    });

    test('can where', (){
      expect(_where, equals(['Snuffleupagus']));
    });

    test('can fold', (){
      expect(_fold, equals(31));
    });
  });
}
