#!/bin/bash
#---
# Excerpted from "Dart for Hipsters",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/csdart for more book information.
#---

# Start the test server
packages/plummbur_kruk/start.sh

# Run a set of Dart Unit tests
results=$(content_shell --dump-render-tree index.html 2>&1)
echo -e "$results"

# Stop the server
packages/plummbur_kruk/stop.sh

# check to see if DumpRenderTree tests
# fails, since it always returns 0
if [[ "$results" == *"Some tests failed"* ]]
then
    exit 1
fi

# Static type analysis
echo
echo "Static type analysis (expecting 5 warnings)..."

results=$(dartanalyzer --no-hints test.dart 2>&1)
echo "$results"
if [[ "$results" == *"[error]"* ]]
then
    exit 1
fi

# 2 in primitives/types.dart
# 2 in varying_the_behavior/test/calling_methods_from_no_such_method.dart
# 1 in varying_the_behavior/public/scripts/HipsterSync.dart (TODO: bug?)
if [[ "$results" != *"5 warnings found."* ]]
then
    echo
    echo "Unexpected warnings found. There should be 5 and only 5."
    exit 1
fi

echo
echo "Looks good!"
# TODO: grep TODOs
