library hipster_collection;

import 'dart:html';
import 'dart:convert';

import 'HipsterModel.dart';
import 'HipsterSync.dart';

abstract class HipsterCollection implements Iterable {
  List<HipsterModel> models = [];
  Map<String,Map> data;

  HipsterModel modelMaker(attrs);
  String get url;

  // Be List-like
  get iterator => models.iterator;

  // Be Backbone like
  operator [](id) {
    var ret;
    forEach((model) {
      if (model['id'] == id) ret = model;
    });
    return ret;
  }

  fetch() {
    HipsterSync.send('get', this, options: {
      'onLoad': _handleOnLoad
    });
  }

  create(attrs) {
    var new_model = modelMaker(attrs);
    new_model.collection = this;
    new_model.save(callback:(event) {
      this.add(new_model);
    });
  }

  add(model) {
    models.add(model);
  }

  _handleOnLoad(list) {
    list.forEach((attrs) {
      var new_model = modelMaker(attrs);
      new_model.collection = this;
      models.add(new_model);
    });
  }
}
